<?php
namespace p123on;

/**
 * Frontend Pages Handler
 */
class Frontend {

    public function __construct() {
        add_shortcode( 'video_123on', [ $this, 'p123on_render_frontend' ] );
    }

    /**
     * Render frontend app
     *
     * @param  array $atts
     * @param  string $content
     *
     * @return string
     */
    public function p123on_render_frontend( $atts, $content = '' ) {
        wp_enqueue_style( 'p123on-frontend' );
        wp_enqueue_script( 'p123on-frontend' );
        wp_enqueue_style( 'wpb-google-fonts', 'https://fonts.googleapis.com/css2?family=Roboto:ital,wght@0,100;0,300;0,400;0,500;0,700;0,900;1,100;1,300;1,400;1,500;1,700;1,900&display=swap');
        $video = get_post($atts['id']);
        $video_content_id = get_post($video->post_content);
        $video_content = $video_content_id->guid;
        $meta = get_post_meta($video->ID, 'hot_spots');
        $hotspots = json_decode($meta[0], true);

        $hotspot_image_1 = plugin_dir_url( __FILE__ ) . '../assets/img/hotspot-yellow.png';
        $hotspot_image_2 = plugin_dir_url( __FILE__ ) . '../assets/img/transparent-hotspot.png';
        $hotspot_image_3 = plugin_dir_url( __FILE__ ) . '../assets/img/hotspot-white.png';
        $popup_arrow_left = plugin_dir_url( __FILE__ ) . '../assets/img/popup-arrow-left.png';
        $popup_arrow_right = plugin_dir_url( __FILE__ ) . '../assets/img/popup-arrow-right.png';
        
        $content .=
              "<div class='container'>
                    <video autoplay loop muted width='720px' height='480px' controlsList='nofullscreen' class='video' data-video=". $video->ID ." data-hotspot1=". $hotspot_image_1 ." data-hotspot2=". $hotspot_image_2 ." data-hotspot3=". $hotspot_image_3 ."  controls playsinline>
                        <source src='". $video_content ."'>
                    </video>";
                    foreach($hotspots as $hotspot)
                    {
                        if ( class_exists( 'WooCommerce' ) ) {
                            $product = wc_get_product( $hotspot['product_id'] );
                            $content .= 
                            "<div id='overlay' class='overlay'>
                                <a id='overlay__hyperlink' target='_blank'><img id='overlay__img' alt='button image'></a>
                            </div>";

                            if(is_a($product, 'WC_Product') && $hotspot['option'] == 'product')
                            {
                                $content .="
                                
                                <div class='product__popup'>
                                    <div class='product__info-container'>
                                        <div><img class='product__thumbnail' src='". wp_get_attachment_url( $product->get_image_id() ) ."'></div>
                                        <div class='product-data__container'>
                                            <span class='product__name'>". $product->get_name() ."</span>
                                            <span class='product__price'>".get_woocommerce_currency_symbol() . ' ' . $product->get_price() ."</span>
                                            <a href='' class='product__button' target='_blank'>Shop now</a>
                                        </div>
                                    </div>
                                    <div class='minimize__popup'><a class='minimize__popup-btn' href=''><div class='minimize__popup-arrow-left'><img src=". $popup_arrow_left ."></div><div class='minimize__popup-arrow-right'><img src=". $popup_arrow_right ."></div></a></div>
                                </div>";
                            }
                        }
                        if($hotspot['option'] == 'custom-product')
                        {
                            $content .="
                            
                            <div class='product__popup'>
                                <div class='product__info-container'>
                                    <div><img class='product__thumbnail' src=''></div>
                                    <div class='product-data__container'>
                                        <span class='product__name'></span>
                                        <span class='product__price'></span>
                                        <a href='' class='product__button' target='_blank'>Shop now</a>
                                    </div>
                                </div>
                                <div class='minimize__popup'><a class='minimize__popup-btn' href=''><div class='minimize__popup-arrow-left'><img src=". $popup_arrow_left ."></div><div class='minimize__popup-arrow-right'><img src=". $popup_arrow_right ."></div></a></div>
                            </div>";
                        }
                    }

              $content .= " </div>
           ";
        return $content;
    }
}
