import Vue from 'vue'
import App from './App.vue'
import router from './router'
import axios from 'axios'

Vue.config.productionTip = false

/* eslint-disable no-new */
// new Vue({
//   el: '#vue-frontend-app',
//   router,
//   render: h => h(App, {
//     props:{
//       id: parseInt(document.querySelector("#vue-frontend-app").dataset.video)
//     }
//   })
// })
jQuery(document).ready(function($) {
    const videos = [...document.querySelectorAll('.video')]

    videos.filter(video => video.addEventListener('timeupdate', e => {
        axios.get('/wp-json/v2/video_123on/video_meta/' + e.target.dataset.video)
            .then(response => {  
                video.allowFullscreen = false;
                let hotspots = JSON.parse(JSON.parse(response.data));
                let overlays = [];
                let hotspotHyperlinks = [];
                let hotspotImages = [];
                let node = video.parentNode.firstChild;
                while ( node ) {
                    if ( node !== video && node.nodeType === Node.ELEMENT_NODE )
                    if($(node).hasClass('overlay'))
                    { 
                        overlays.push( node );
                    }
                    node = node.nextElementSibling || node.nextSibling;
                }

                overlays.forEach(function(item) {
                    hotspotHyperlinks.push($(item).children("a"));
                });

                hotspotHyperlinks.forEach(function(item) {
                    hotspotImages.push($(item).children("img"));
                });
                
                let vidCurrentTime = e.target.currentTime;

                for (let i=0; i< hotspots.length; i++) {
                    if (format(vidCurrentTime) >= hotspots[i].startTime && format(vidCurrentTime) < hotspots[i].stopTime) {
                        if(hotspots[i].btn_option == '1')
                        {
                            hotspotImages[i].attr('src', e.target.dataset.hotspot1);
                        }
                        if(hotspots[i].btn_option == '2')
                        {
                            hotspotImages[i].attr('src', e.target.dataset.hotspot2);
                            $(overlays[i]).addClass('overlay-transparent');
                            hotspotHyperlinks[i].addClass('hyperlink-transparent');
                        }
                        if(hotspots[i].btn_option == '3')
                        {
                            hotspotImages[i].attr('src', e.target.dataset.hotspot3);
                        }
                        hotspotHyperlinks[i].attr('href', hotspots[i].value);
                        $(overlays[i]).css('top',  hotspots[i].position_y + '%');
                        $(overlays[i]).css('left', hotspots[i].position_x + '%');
                        if(hotspots[i].option == 'product')
                        {
                            let popup = $(overlays[i]).nextAll(".product__popup:first").css('display', 'flex');
                            $(popup).find(".product__button").attr("href", hotspots[i].value);
                        }
                        if(hotspots[i].option == 'custom-product')
                        {
                            let popup = $(overlays[i]).nextAll(".product__popup:first").css('display', 'flex');
                            $(popup).find(".product__name").text(hotspots[i].custom_product.name);
                            $(popup).find(".product__price").text(hotspots[i].custom_product.price);
                            if (!/^https?:\/\//i.test(hotspots[i].custom_product.link)) {
                                hotspots[i].custom_product.link = 'http://' + hotspots[i].custom_product.link;
                            }
                            $(popup).find(".product__button").attr("href", hotspots[i].custom_product.link);
                            $(popup).find(".product__thumbnail").attr("src", hotspots[i].custom_product.image_url);
                            hotspotHyperlinks[i].attr('href', hotspots[i].custom_product.link);
                        }
                        $(overlays[i]).css('display', 'flex');
                    }
                    else {
                        $(overlays[i]).hide();
                        $(overlays[i]).nextAll(".product__popup:first").hide();
                    }
                }

                function format(s) {
                    let m = Math.floor(s / 60);
                    m = (m >= 10) ? m : '0' + m;
                    s = Math.floor(s % 60);
                    s = (s >= 10) ? s : '0' + s;
                    return m + ':' + s;
                }
            })
    }));

    $(".minimize__popup-btn").on("click", function (e) {
        e.preventDefault();
        if($(this).parent().siblings(".product__info-container").hasClass("product__info-container--minimized"))
        {
            $(this).parent().parent().removeClass("product__popup--minimized");
            $(this).parent().siblings(".product__info-container").removeClass("product__info-container--minimized");
            $(this).parent().siblings(".product__info-container").find(".product-data__container").removeClass("product-data__container--minimized");
            $(this).parent().siblings(".product__info-container").find(".product__thumbnail").removeClass("product__thumbnail--minimized");
            $(this).find(".minimize__popup-arrow-left").removeClass("minimize__popup-arrow-left--minimized");
            $(this).find(".minimize__popup-arrow-right").removeClass("minimize__popup-arrow-right--minimized");
        }
        else
        {
            $(this).parent().parent().addClass("product__popup--minimized");
            $(this).parent().siblings(".product__info-container").addClass("product__info-container--minimized");
            $(this).parent().siblings(".product__info-container").find(".product-data__container").addClass("product-data__container--minimized");
            $(this).parent().siblings(".product__info-container").find(".product__thumbnail").addClass("product__thumbnail--minimized");
            $(this).find(".minimize__popup-arrow-left").addClass("minimize__popup-arrow-left--minimized");
            $(this).find(".minimize__popup-arrow-right").addClass("minimize__popup-arrow-right--minimized");
        }
    });
})
